﻿
#pragma once
#define CUBAPI __stdcall

#define CUB_SUCCESS                             0   /* 正常終了                                               */
#define CUB_ERR_DEVICENOTEXIST                  1   /* デバイスが存在しない                                   */
#define CUB_ERR_ALREADYOPENED                   2   /* すでにオープンされている                               */
#define CUB_ERR_CLOSED                          3   /* CubOpenHandle()が一度もコールされていない              */
#define CUB_ERR_INVALIDPARAM                    4   /* 無効なパラメータでコールされた                         */
#define CUB_ERR_NORESOUCE                       5   /* 実行に必要なリソースが足りない                         */
#define CUB_ERR_FAILED                          6   /* 原因不明により処理が遂行されなかった                   */
#define CUB_ERR_AUTO_TRANS_ALREADY_START        7   /* 定期更新がすでに開始されている                         */
#define CUB_ERR_AUTO_TRANS_STOP                 8   /* 定期更新が開始されていない                             */
#define CUB_ERR_USB_TIMEOUT_SUCCESS_STOP_CUNET  9   /* USB通信中にタイムアウトが発生、CUNET通信の停止に成功   */
#define CUB_ERR_USB_TIMEOUT_FAILED_STOP_CUNET   10  /* USB通信中にタイムアウトが発生、CUNET通信の停止に失敗   */
#define CUB_ERR_REACQUISITION_OF_HANDLE         11  /* ハンドルの再取得が行われていない                       */
#define CUB_NOT_CALLYET                         99  /* まだ1度もCUBAPIがコールされていない                    */

#define CUB_MSEC_TO_MFCNT(ms)   (WORD)(((DWORD)(ms) * 1000U) / 125U)
#define CUB_USEC_TO_MFCNT(us)   (WORD)(((us) / 125U))

#ifdef __cplusplus
extern "C" {
#endif

UINT   CUBAPI CubGetVersion(void);
UINT   CUBAPI CubGetLastError(void);
INT    CUBAPI CubCountDevice(void);
BOOL   CUBAPI CubSearchBoard(BYTE *board_num, BYTE *board_id_list);
BOOL   CUBAPI CubStartAutoTrans(HANDLE CUBHandle, WORD MfCnt);
BOOL   CUBAPI CubStopAutoTrans(HANDLE CUBHandle);
HANDLE CUBAPI CubOpenHandle(int Instance);
BOOL   CUBAPI CubCloseHandle(HANDLE CUBHandle);
BOOL   CUBAPI CubReadWord(HANDLE CUBHandle, const ULONG Adr, WORD* Dat);
BOOL   CUBAPI CubWriteWord(HANDLE CUBHandle, const ULONG Adr, const WORD Dat);
BOOL   CUBAPI CubReadProtect(HANDLE CUBHandle, WORD Bno, void* Data);
BOOL   CUBAPI CubWriteProtect(HANDLE CUBHandle, WORD Bno, void* Data);
BOOL   CUBAPI CubReadGM(HANDLE CUBHandle, void* Data);
BOOL   CUBAPI CubReadMFR(HANDLE CUBHandle, void* Data);
BOOL   CUBAPI CubReadData(HANDLE CUBHandle, WORD Adr, WORD WordLen, void* Data);
BOOL   CUBAPI CubWriteData(HANDLE CUBHandle, WORD Adr, WORD WordLen, void* Data);
INT    CUBAPI CubBoardID(HANDLE CUBHandle);

    
#ifdef __cplusplus
}
#endif
